class Stack:

    def __init__(self):
        self.array = [0]
        self.top = -1

    def push(self, value):
        n = len(self.array)
        if self.top == n - 1:
            nuova_dim = 2 * n
            nuovo_array = [0] * nuova_dim
            for i in range(0, n):
                nuovo_array[i] = self.array[i]
            self.array = nuovo_array
        self.top = self.top + 1
        self.array[self.top] = value

    def pop(self):
        # assumiamo stack non vuoto
        valore = self.array[self.top]
        self.top = self.top - 1
        return valore

    def peek(self):
        # assumiamo stack non vuoto
        return self.array[self.top]

    def empty(self):
        return self.top == -1

    def __str__(self):
        s = ""
        for i in range(0, self.top + 1):
            s += str(self.array[i]) + " "
        s += "<- top"
        return s


# assumiamo che le formule siano rappresentate come
# array di stringhe.
# ['2', '3', '+', '4', '*'] -> 2 3 + 4 *
def valuta_rpn(formula):
    s = Stack()
    for i in range(0, len(formula)):
        # più casi a seconda del valore
        # contenuto in posizione i-esima
        if formula[i] == '+':
            b = s.pop()
            a = s.pop()
            s.push(a + b)
        elif formula[i] == '*':
            b = s.pop()
            a = s.pop()
            s.push(a * b)
        else:  # assumiamo sia un numero intero
            n = int(formula[i])
            s.push(n)
        print(s)
    return s.pop()


def ottieni_input():
    print("inserisci la formula:")
    x = input()
    risultato = valuta_rpn(x.split())
    print(risultato)
