# classe nodo per i nodi della lista
class Nodo:

    def __init__(self, value, succ):
        self.value = value
        self.succ = succ


# classe stack implentata con lista
# concatenata singola
class Stack:

    def __init__(self):
        self.testa = None

    def push(self, value):
        nuovo_nodo = Nodo(value, self.testa)
        self.testa = nuovo_nodo

    def pop(self):
        # assumiamo stack non vuoto
        nodo = self.testa
        self.testa = self.testa.succ
        return nodo.value

    def peek(self):
        # assumiamo stack non vuoto
        return self.testa.value

    def empty(self):
        return self.testa is None

    def __str__(self):
        s = "top -> "
        nodo_corrente = self.testa
        while nodo_corrente is not None:
            s += str(nodo_corrente.value) + " "
            nodo_corrente = nodo_corrente.succ
        return s


# assumiamo che le formule siano rappresentate come
# array di stringhe.
# ['2', '3', '+', '4', '*'] -> 2 3 + 4 *
def valuta_rpn(formula):
    s = Stack()
    for i in range(0, len(formula)):
        # più casi a seconda del valore
        # contenuto in posizione i-esima
        if formula[i] == '+':
            b = s.pop()
            a = s.pop()
            s.push(a + b)
        elif formula[i] == '*':
            b = s.pop()
            a = s.pop()
            s.push(a * b)
        else:  # assumiamo sia un numero intero
            n = int(formula[i])
            s.push(n)
        print(s)
    return s.pop()


def ottieni_input():
    print("inserisci la formula:")
    x = input()
    risultato = valuta_rpn(x.split())
    print(risultato)
    
